// Programmname:  TimeDate    (Freeware)
// Autor:  Achim Baur     (http://ourworld.compuserve.com/homepages/Page_Baur)
// Version:  1.01    
// Datum:  25.05.97
// Funktion: Ausgabe einer digitalen Uhr

import java.awt.*;
import java.applet.Applet;
import java.util.Date;
import java.lang.*;

public class timedate01 extends java.applet.Applet implements Runnable {
  Date Datum;

 Thread animator;

  Font font1;

  Image Image1;
  Graphics Bild;

  int PosX;
  int Zaehler;

 int Sekunden;
 int Minuten;
 int Stunden;
 int NummerWochentag;
 int NummerMonat;
 int NummerJahr;
 int NummerMonatTag;
 int Parameter1;
 int Parameter2;
 int Parameter3;

 Color Color1;   // LED-Farbe
 Color Color2;   // Hintergrundfarbe
 Color Color3;  // Datumsfarbe
 Font Schrift;

 int Hoehe; //wirkliche Hoehe des Fonts
 int Breite; //wirkliche Breite des Strings
 

 public String getAppletInfo()
    {
        return new String("TimeDate  Version 1.01 Mai 1997 by Achim Baur");
    }

 public String[][] getParameterInfo()
    {
    String[][] info =
          {
          {"forecolorR","integer","LED Farbe, Rotanteil 0-255"},
          {"forecolorG","integer","LED Farbe, Gruenanteil 0-255"},
          {"forecolorB","integer","LED Farbe, Blauanteil 0-255"},
          {"backcolorR","integer","Hintergrundfarbe, Rotanteil 0-255"},
          {"backcolorG","integer","Hintergrundfarbe, Gruenanteil 0-255"},
          {"backcolorB","integer","Hintergrundfarbe, Blauanteil 0-255"},
          {"datecolorR","integer","Farbe des Datums, Rotanteil 0-255"},
          {"datecolorG","integer","Farbe des Datums, Gruenanteil 0-255"},
          {"datecolorB","integer","Farbe des Datums, Blauanteil 0-255"},
          };
         return info;
   }
  public void init() {
        
   //Parameter lesen
   // LED-Farbe
    Parameter1 = Integer.valueOf(getParameter("forecolorR")).intValue();
    Parameter2 = Integer.valueOf(getParameter("forecolorG")).intValue();
    Parameter3 = Integer.valueOf(getParameter("forecolorB")).intValue();
    Color1 = new Color(Parameter1,Parameter2, Parameter3);

   // Hintergrundfarbe
    Parameter1 = Integer.valueOf(getParameter("backcolorR")).intValue();
    Parameter2 = Integer.valueOf(getParameter("backcolorG")).intValue();
    Parameter3 = Integer.valueOf(getParameter("backcolorB")).intValue();
    Color2 = new Color(Parameter1,Parameter2,Parameter3);

    //Datumsfarbe
    Parameter1 = Integer.valueOf(getParameter("datecolorR")).intValue();
    Parameter2 = Integer.valueOf(getParameter("datecolorG")).intValue();
    Parameter3 = Integer.valueOf(getParameter("datecolorB")).intValue();
    Color3 = new Color(Parameter1,Parameter2,Parameter3);

     // Double Buffering
      Image1 = createImage(220,50);
      Bild = Image1.getGraphics();



  Schrift = new Font("Arial",0,12);
  Datum = new Date();
  Sekunden = Datum.getSeconds();
  Minuten    =  Datum.getMinutes();
  Stunden    = Datum.getHours();
  NummerWochentag = Datum.getDay();
  NummerMonat = Datum.getMonth();
  NummerJahr = Datum.getYear();
  NummerMonatTag = Datum.getDate();

}
 
public void start() {
		animator = new Thread(this);
		animator.start();
	}

public void stop()
  {
  if (animator !=null) animator.stop();
     animator=null;
  }

public void Oben(int PosX, Graphics g)
  {
  g.drawLine(PosX,10,PosX+12,10);
  g.drawLine(PosX+1,11,PosX+11,11);
  g.drawLine(PosX+2,12,PosX+10,12);
   }

public void Mitte(int PosX, Graphics g)
  {
  g.drawLine(PosX+2,24,PosX+10,24);
  g.drawLine(PosX,25,PosX+12,25);
  g.drawLine(PosX+2,26,PosX+10,26);
  }

public void ObenLinks( int PosX, Graphics g)
  {
  g.drawLine(PosX+1,14,PosX+1,21);
  g.drawLine(PosX,13,PosX,22);
  g.drawLine(PosX-1,12,PosX-1,23);
  }

public void ObenRechts(int PosX, Graphics g)
  {
 g.drawLine(PosX+11,14,PosX+11,21);
 g.drawLine(PosX+12,13,PosX+12,22);
 g.drawLine(PosX+13,12,PosX+13,23);
  }

public void UntenLinks(int PosX, Graphics g)
 {
  g.drawLine(PosX-1,27,PosX-1,38);
 g.drawLine(PosX,28,PosX,37);
 g.drawLine(PosX+1,29,PosX+1,36);
 }

public void UntenRechts(int PosX, Graphics g)
 {
 g.drawLine(PosX+11,29,PosX+11,36);
 g.drawLine(PosX+12,28,PosX+12,37);
 g.drawLine(PosX+13,27,PosX+13,38);
 }

public void Unten(int PosX, Graphics g)
 {
 g.drawLine(PosX+1,39,PosX+11,39);
 g.drawLine(PosX,40,PosX+12,40);
 g.drawLine(PosX+2,38,PosX+10,38);
 }


public  void Z0(int PosX, Graphics g)
  {
  Oben(PosX,g);
  ObenRechts(PosX,g);
  UntenRechts(PosX,g);
  Unten(PosX,g);
  UntenLinks(PosX,g);
  ObenLinks(PosX,g);
  }

public  void Z1(int PosX, Graphics g)
 {
 ObenRechts(PosX, g);
 UntenRechts(PosX, g);
 }

public void Z2(int PosX, Graphics g)
 {
 Oben(PosX,g);
 ObenRechts(PosX,g);
 Mitte(PosX,g);
 UntenLinks(PosX,g);
 Unten(PosX,g);
 }

public void Z3(int PosX, Graphics g)
 {
 Oben(PosX,g);
 ObenRechts(PosX,g);
 Mitte(PosX,g);
 UntenRechts(PosX,g);
 Unten(PosX,g);
 }

public void Z4(int PosX, Graphics g)
 {
 ObenLinks(PosX,g);
 ObenRechts(PosX,g);
 Mitte(PosX,g);
 UntenRechts(PosX,g);
 }

public void Z5(int PosX, Graphics g)
 {
 Oben(PosX,g);
 ObenLinks(PosX,g);
 Mitte(PosX,g);
 UntenRechts(PosX,g);
 Unten(PosX,g);
 }

public void Z6(int PosX, Graphics g)
 {
 ObenLinks(PosX,g);
 Mitte(PosX,g);
 UntenLinks(PosX,g);
 Unten(PosX,g);
 UntenRechts(PosX,g);
 }

public void Z7(int PosX, Graphics g)
 {
 ObenRechts(PosX,g);
 UntenRechts(PosX,g);
 Oben(PosX,g);
 }

public void Z8(int PosX, Graphics g)
 {
 Oben(PosX,g);
 Mitte(PosX,g);
 ObenLinks(PosX,g);
 UntenLinks(PosX,g);
 Unten(PosX,g);
 ObenRechts(PosX,g);
 UntenRechts(PosX,g);
 }

public void Z9(int PosX, Graphics g)
 {
 Oben(PosX,g);
 Mitte(PosX,g);
 ObenLinks(PosX,g);
 ObenRechts(PosX,g);
 UntenRechts(PosX,g);
 Unten(PosX,g);
 }

public void PaintZahl(int PosX, Graphics g, int Zahl)
  {
  switch (Zahl) 
   {
   case 0 : Z0(PosX,g);
                break;
   case 1 :  Z1(PosX,g);
                 break;
   case 2 :  Z2(PosX,g);
                 break;
   case 3 :  Z3(PosX,g);
                 break;
   case 4 : Z4(PosX,g);
                 break;
   case 5 : Z5(PosX,g);
                 break;
   case 6 : Z6(PosX,g);
                 break;
   case 7 : Z7(PosX,g);
                 break;
   case 8 : Z8(PosX,g);
                 break;
   case 9 : Z9(PosX,g);
                  break;
   }
}

public void PaintDatumRest(Graphics g)
  {
  String Ausgabe;
  String Ausgabe1;
  String Ausgabe2;
  g.setFont(Schrift);
  g.setColor(Color3);
  
  Ausgabe = Integer.toString(NummerMonat+1);
  Ausgabe1 = Integer.toString(NummerJahr);
  Ausgabe2 = Integer.toString(NummerMonatTag); 
 g.drawString(Ausgabe2+"."+Ausgabe+'.'+Ausgabe1,150,40);
} 

public void PaintDatum(Graphics g)
  {
  g.setFont(Schrift);
  g.setColor(Color3);

  switch (NummerWochentag) 
     {
     case 1 : g.drawString("Montag",150,20);
                  break;
     case 2 : g.drawString("Dienstag",150,20);
                  break;
     case 3 : g.drawString("Mittwoch",150,20);
                  break;
     case 4: g.drawString("Donnerstag",150,20);
                 break;
     case 5: g.drawString("Freitag",150,20);
                 break;
     case 6: g.drawString("Samstag",150,20);
                 break;
     case 0: g.drawString("Sonntag",150,20);
                break;


      }
    
  }

public void PaintDoppelPunkt(int PosX, Graphics g)
  {
    g.setColor(Color1);
    g.fillRect(PosX,17,4,4);
    g.fillRect(PosX,32,4,4);
  }

public void PaintHintergrund(Graphics g)
  {
   //Rahmen
   g.setColor(Color2);
   g.fillRect(0,0,219,49);
   
  

 g.setColor(Color1);


//Anfang X-Wert
PosX = 10;




//10 Stelle Sekunden
Zaehler = (Sekunden/10);
PaintZahl(110,g,Zaehler);

Zaehler = Sekunden- Zaehler * 10;

//1 Stelle Sekunden
PaintZahl(130,g,Zaehler);


//10 Stelle Minuten
Zaehler = (Minuten/10);
PaintZahl(65,g,Zaehler);

//1 Stelle Minuten
Zaehler = Minuten-Zaehler * 10;
PaintZahl(85,g,Zaehler);



// 10 Stelle Stunden
Zaehler = (Stunden/10);
PaintZahl(20,g,Zaehler);

//1 Stelle Stunden
Zaehler = Stunden-Zaehler * 10;
PaintZahl(40,g,Zaehler);

PaintDoppelPunkt(85+17,g);
PaintDoppelPunkt(57,g);

PaintDatum(g);
PaintDatumRest(g);


  } 

  public void update(Graphics g)
  {
  PaintHintergrund(Bild);
  g.drawImage(Image1,0,0,this);
 }

public void run() {
		while (animator != null) {
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				break;
			}
                                                 Datum = new Date();
			Sekunden = Datum.getSeconds();
                                                Minuten    =  Datum.getMinutes();
                                                Stunden    = Datum.getHours();
                                                NummerWochentag = Datum.getDay();
                                                NummerMonat = Datum.getMonth();
                                                NummerJahr = Datum.getYear();
                                                NummerMonatTag = Datum.getDate();
                                               repaint();
                                               
		}

 }



  public void paint(Graphics g) {

       PaintHintergrund(Bild);
       g.drawImage(Image1,0,0,this);
 
         }
}
